using System;
using DataDynamics.Reports;
using System.IO;
using System.Text;
using DataDynamics.Reports.Extensibility.Rendering.IO;
using DataDynamics.Reports.Rendering.Html;
using System.Net.Mail;
using System.Net.Mime;

namespace DataDynamicsReportTest
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            ReportDefinition def = new ReportDefinition(new System.IO.FileInfo(Server.MapPath("~/reportfile")));
            ReportRuntime run = new ReportRuntime(def);
           
            SmtpClient sc = new SmtpClient("ip-address");
            MailMessage msg = new MailMessage();

            EmailRenderingExtension renderer2 = new EmailRenderingExtension();
            
            MemoryStreamProvider provider2 = new MemoryStreamProvider();
            run.Render(renderer2, provider2);
            MemoryStreamProvider.MemoryStreamInfo memoryStreamInfo2 = provider2.GetPrimaryStream() as MemoryStreamProvider.MemoryStreamInfo;
            AlternateView htmlMessage2 = null;
            if (memoryStreamInfo2 != null)
            {
                MemoryStream memoryStream = memoryStreamInfo2.OpenStream() as MemoryStream;
                byte[] data = memoryStream.ToArray();
                htmlMessage2 = AlternateView.CreateAlternateViewFromString(
                    Encoding.UTF8.GetString(data), Encoding.UTF8, "text/html");
                htmlMessage2.TransferEncoding = TransferEncoding.QuotedPrintable;
            }
            StreamInfo[] secondaryStreams2 = provider2.GetSecondaryStreams();
            foreach (StreamInfo secStream in secondaryStreams2)
            {
                if (secStream != null)
                {
                    MemoryStream memoryStream = secStream.OpenStream() as MemoryStream;
                    byte[] data = memoryStream.ToArray();
                    MemoryStream resourceStream = new MemoryStream();
                    resourceStream.Write(data, 0, data.Length);
                    resourceStream.Position = 0;
                    LinkedResource linkedRes = new LinkedResource(resourceStream, secStream.MimeType);
                    linkedRes.ContentId = secStream.Uri.LocalPath;
                    linkedRes.TransferEncoding = TransferEncoding.Base64;
                    htmlMessage2.LinkedResources.Add(linkedRes);
                }
            }

            msg.AlternateViews.Add(htmlMessage2);
            
            msg.SubjectEncoding = Encoding.UTF8;

            msg.From = new MailAddress("anjo@multinet.se");
            msg.To.Add("anjo@multinet.se");
            msg.Subject = "Report Test";
            sc.Send(msg);
        }

    }
}